local _, AT = ...

local Settings = AT.Settings

local BUFF_INFO = AT.Enums.BUFF_INFO
local SCAN_CATEGORY = AT.Enums.SCAN_CATEGORY
local SCAN_RESULT = AT.Enums.SCAN_RESULT

local TestData = {}
AT.TestData = TestData

TestData.data = {
  {
    [SCAN_RESULT.UNIT] = "Your target",
    [SCAN_RESULT.UNIT_GUID] = nil,
    [SCAN_RESULT.CATEGORY] = SCAN_CATEGORY.TARGET,
    [SCAN_RESULT.BUFFS_INFO] = {
      {
        [BUFF_INFO.NAME] = nil,
        [BUFF_INFO.ICON] = nil,
        [BUFF_INFO.COUNT] = 0,
        [BUFF_INFO.EXPIRATION_TIME] = 40,
        [BUFF_INFO.ID] = 80353,
        [BUFF_INFO.SHOW_IN_MOUSEOVER] = false,
        [BUFF_INFO.SHOW_IN_OVERVIEW] = true,
        [BUFF_INFO.SHOW_IN_NAMEPLATE] = false,
      }
    },
    [SCAN_RESULT.HAS_IMPORTANT_BUFFS] = true,
    [SCAN_RESULT.HAS_MOUSEOVER_BUFFS] = false,
    [SCAN_RESULT.HAS_OVERVIEW_BUFFS] = nil,
    [SCAN_RESULT.HAS_NAMEPLATE_BUFFS] = false,
  },
  {
    [SCAN_RESULT.UNIT] = "Your focus",
    [SCAN_RESULT.UNIT_GUID] = nil,
    [SCAN_RESULT.CATEGORY] = SCAN_CATEGORY.FOCUS,
    [SCAN_RESULT.BUFFS_INFO] = {
      {
        [BUFF_INFO.NAME] = nil,
        [BUFF_INFO.ICON] = nil,
        [BUFF_INFO.COUNT] = 5,
        [BUFF_INFO.EXPIRATION_TIME] = 40,
        [BUFF_INFO.ID] = 32182,
        [BUFF_INFO.SHOW_IN_MOUSEOVER] = false,
        [BUFF_INFO.SHOW_IN_OVERVIEW] = nil,
        [BUFF_INFO.SHOW_IN_NAMEPLATE] = false,
      }
    },
    [SCAN_RESULT.HAS_IMPORTANT_BUFFS] = true,
    [SCAN_RESULT.HAS_MOUSEOVER_BUFFS] = false,
    [SCAN_RESULT.HAS_OVERVIEW_BUFFS] = nil,
    [SCAN_RESULT.HAS_NAMEPLATE_BUFFS] = false,
  },
  {
    [SCAN_RESULT.UNIT] = "Your mouseover target",
    [SCAN_RESULT.UNIT_GUID] = nil,
    [SCAN_RESULT.CATEGORY] = SCAN_CATEGORY.MOUSEOVER,
    [SCAN_RESULT.BUFFS_INFO] = {
      {
        [BUFF_INFO.NAME] = nil,
        [BUFF_INFO.ICON] = nil,
        [BUFF_INFO.COUNT] = 0,
        [BUFF_INFO.EXPIRATION_TIME] = 40,
        [BUFF_INFO.ID] = 80353,
        [BUFF_INFO.SHOW_IN_MOUSEOVER] = true,
        [BUFF_INFO.SHOW_IN_OVERVIEW] = nil,
        [BUFF_INFO.SHOW_IN_NAMEPLATE] = false,
      }
    },
    [SCAN_RESULT.HAS_IMPORTANT_BUFFS] = true,
    [SCAN_RESULT.HAS_MOUSEOVER_BUFFS] = nil,
    [SCAN_RESULT.HAS_OVERVIEW_BUFFS] = nil,
    [SCAN_RESULT.HAS_NAMEPLATE_BUFFS] = false,
  },
  {
    [SCAN_RESULT.UNIT] = "Patchwerk",
    [SCAN_RESULT.UNIT_GUID] = nil,
    [SCAN_RESULT.CATEGORY] = SCAN_CATEGORY.BOSS,
    [SCAN_RESULT.BUFFS_INFO] = {
      {
        [BUFF_INFO.NAME] = nil,
        [BUFF_INFO.ICON] = nil,
        [BUFF_INFO.COUNT] = 0,
        [BUFF_INFO.EXPIRATION_TIME] = 40,
        [BUFF_INFO.ID] = 80353,
        [BUFF_INFO.SHOW_IN_MOUSEOVER] = false,
        [BUFF_INFO.SHOW_IN_OVERVIEW] = nil,
        [BUFF_INFO.SHOW_IN_NAMEPLATE] = false,
      },
      {
        [BUFF_INFO.NAME] = nil,
        [BUFF_INFO.ICON] = nil,
        [BUFF_INFO.COUNT] = 0,
        [BUFF_INFO.EXPIRATION_TIME] = 40,
        [BUFF_INFO.ID] = 2825,
        [BUFF_INFO.SHOW_IN_MOUSEOVER] = false,
        [BUFF_INFO.SHOW_IN_OVERVIEW] = nil,
        [BUFF_INFO.SHOW_IN_NAMEPLATE] = false,
      },
      {
        [BUFF_INFO.NAME] = nil,
        [BUFF_INFO.ICON] = nil,
        [BUFF_INFO.COUNT] = 0,
        [BUFF_INFO.EXPIRATION_TIME] = 40,
        [BUFF_INFO.ID] = 32182,
        [BUFF_INFO.SHOW_IN_MOUSEOVER] = false,
        [BUFF_INFO.SHOW_IN_OVERVIEW] = nil,
        [BUFF_INFO.SHOW_IN_NAMEPLATE] = false,
      }
    },
    [SCAN_RESULT.HAS_IMPORTANT_BUFFS] = false,
    [SCAN_RESULT.HAS_MOUSEOVER_BUFFS] = false,
    [SCAN_RESULT.HAS_OVERVIEW_BUFFS] = nil,
    [SCAN_RESULT.HAS_NAMEPLATE_BUFFS] = false,
  },
  {
    [SCAN_RESULT.UNIT] = "Random dude 1",
    [SCAN_RESULT.UNIT_GUID] = nil,
    [SCAN_RESULT.CATEGORY] = SCAN_CATEGORY.NAMEPLATE,
    [SCAN_RESULT.BUFFS_INFO] = {
      {
        [BUFF_INFO.NAME] = nil,
        [BUFF_INFO.ICON] = nil,
        [BUFF_INFO.COUNT] = 0,
        [BUFF_INFO.EXPIRATION_TIME] = 40,
        [BUFF_INFO.ID] = 80353,
        [BUFF_INFO.SHOW_IN_MOUSEOVER] = false,
        [BUFF_INFO.SHOW_IN_OVERVIEW] = nil,
        [BUFF_INFO.SHOW_IN_NAMEPLATE] = false,
      }
    },
    [SCAN_RESULT.HAS_IMPORTANT_BUFFS] = false,
    [SCAN_RESULT.HAS_MOUSEOVER_BUFFS] = false,
    [SCAN_RESULT.HAS_OVERVIEW_BUFFS] = nil,
    [SCAN_RESULT.HAS_NAMEPLATE_BUFFS] = false,
  },
  {
    [SCAN_RESULT.UNIT] = "Random dude 2",
    [SCAN_RESULT.UNIT_GUID] = nil,
    [SCAN_RESULT.CATEGORY] = SCAN_CATEGORY.NAMEPLATE,
    [SCAN_RESULT.BUFFS_INFO] = {
      {
        [BUFF_INFO.NAME] = nil,
        [BUFF_INFO.ICON] = nil,
        [BUFF_INFO.COUNT] = 0,
        [BUFF_INFO.EXPIRATION_TIME] = 40,
        [BUFF_INFO.ID] = 80353,
        [BUFF_INFO.SHOW_IN_OVERVIEW] = true
      }
    },
    [SCAN_RESULT.HAS_IMPORTANT_BUFFS] = false,
    [SCAN_RESULT.HAS_MOUSEOVER_BUFFS] = false,
    [SCAN_RESULT.HAS_OVERVIEW_BUFFS] = nil,
    [SCAN_RESULT.HAS_NAMEPLATE_BUFFS] = false,
  },
}

function TestData:Refresh()
  for _, scanResult in ipairs(self.data) do
    scanResult[SCAN_RESULT.HAS_OVERVIEW_BUFFS] = false
    for _, buffInfo in ipairs(scanResult[SCAN_RESULT.BUFFS_INFO]) do
      local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(buffInfo[BUFF_INFO.ID])
      local _, _, isOverviewEntry, _ = AT.Main:FilterContextual(scanResult[SCAN_RESULT.CATEGORY], buffInfo[BUFF_INFO.ID], name, buffInfo[BUFF_INFO.EXPIRATION_TIME])
      buffInfo[BUFF_INFO.NAME] = name
      buffInfo[BUFF_INFO.ICON] = icon
      buffInfo[BUFF_INFO.SHOW_IN_OVERVIEW] = isOverviewEntry
      if isOverviewEntry then
        scanResult[SCAN_RESULT.HAS_OVERVIEW_BUFFS] = true
      end
    end
    if scanResult[SCAN_RESULT.CATEGORY] == SCAN_CATEGORY.BOSS and not Settings.filterOverviewShowBosses then
      scanResult[SCAN_RESULT.HAS_OVERVIEW_BUFFS] = false
    end
    if scanResult[SCAN_RESULT.CATEGORY] == SCAN_CATEGORY.MOUSEOVER then
      scanResult[SCAN_RESULT.HAS_MOUSEOVER_BUFFS] = Settings.testFramesShowMouseover
    end
  end
end
